'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (ast) {
  _traverser2.default.replace(ast, {
    enter: function enter(node) {
      if (isPlusExpression(node)) {
        this.skip();

        var _flattenPlusExpressio = flattenPlusExpression(node);

        var _flattenPlusExpressio2 = _slicedToArray(_flattenPlusExpressio, 2);

        var operands = _flattenPlusExpressio2[0];
        var isStringConcatenation = _flattenPlusExpressio2[1];


        if (isStringConcatenation && !operands.every(_isString2.default)) {
          return new _TemplateLiteral2.default(splitQuasisAndExpressions(operands));
        }
      }
    }
  });
};

var _traverser = require('../traverser');

var _traverser2 = _interopRequireDefault(_traverser);

var _TemplateLiteral = require('./../syntax/TemplateLiteral');

var _TemplateLiteral2 = _interopRequireDefault(_TemplateLiteral);

var _TemplateElement = require('./../syntax/TemplateElement');

var _TemplateElement2 = _interopRequireDefault(_TemplateElement);

var _isString = require('./../utils/isString');

var _isString2 = _interopRequireDefault(_isString);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Returns two items:
// - flat array of all the plus operation sub-expressions
// - true when the result of the plus operation is a string
function flattenPlusExpression(node) {
  if (isPlusExpression(node)) {
    var _flattenPlusExpressio3 = flattenPlusExpression(node.left);

    var _flattenPlusExpressio4 = _slicedToArray(_flattenPlusExpressio3, 2);

    var left = _flattenPlusExpressio4[0];
    var leftIsString = _flattenPlusExpressio4[1];

    var _flattenPlusExpressio5 = flattenPlusExpression(node.right);

    var _flattenPlusExpressio6 = _slicedToArray(_flattenPlusExpressio5, 2);

    var right = _flattenPlusExpressio6[0];
    var rightIsString = _flattenPlusExpressio6[1];


    if (leftIsString || rightIsString) {
      return [_lodash2.default.flatten([left, right]), true];
    } else {
      return [node, false];
    }
  } else {
    return [node, (0, _isString2.default)(node)];
  }
}

function isPlusExpression(node) {
  return node.type === 'BinaryExpression' && node.operator === '+';
}

function splitQuasisAndExpressions(operands) {
  var quasis = [];
  var expressions = [];

  for (var i = 0; i < operands.length; i++) {
    var curr = operands[i];

    if ((0, _isString2.default)(curr)) {
      var currVal = curr.value;
      var currRaw = escapeForTemplate(curr.raw);

      while ((0, _isString2.default)(operands[i + 1] || {})) {
        i++;
        currVal += operands[i].value;
        currRaw += escapeForTemplate(operands[i].raw);
      }

      quasis.push(new _TemplateElement2.default({
        raw: currRaw,
        cooked: currVal
      }));
    } else {
      if (i === 0) {
        quasis.push(new _TemplateElement2.default({}));
      }

      if (!(0, _isString2.default)(operands[i + 1] || {})) {
        quasis.push(new _TemplateElement2.default({
          tail: operands[i + 1] === undefined
        }));
      }

      expressions.push(curr);
    }
  }

  return { quasis: quasis, expressions: expressions };
}

// Strip surrounding quotes, escape backticks and unescape escaped quotes
function escapeForTemplate(raw) {
  return raw.replace(/^['"]|['"]$/g, '').replace(/`/g, '\\`').replace(/\\(['"])/g, '$1');
}
module.exports = exports['default'];