'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isEqualAst;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var metaDataFields = {
  comments: true,
  loc: true,
  start: true,
  end: true
};

/**
 * True when two AST nodes are structurally equal.
 * When comparing objects it ignores the meta-data fields for
 * comments and source-code position.
 * @param  {Object}  a
 * @param  {Object}  b
 * @return {Boolean}
 */
function isEqualAst(a, b) {
  return _lodash2.default.isEqualWith(a, b, function (aValue, bValue, key) {
    return metaDataFields[key];
  });
}
module.exports = exports['default'];